%
% Px, Py - puvodni poloha
% Qx, Qy - nova poloha
%
function [ wx wy ] = TPSSolve( Px, Py, Qx, Qy )

n=size(Px,1);

norm = (repmat(Px', n, 1) - repmat(Px, 1, n)).^2 + (repmat(Py', n, 1) - repmat(Py, 1, n)).^2;
U = RBF(sqrt(norm));

M = [ones(n,1) Px Py U;
     zeros(3,3) [ones(1, n); Px'; Py']];
 
Mi = inv(M);

x=[Qx; zeros(3,1)];
y=[Qy; zeros(3,1)];

wx=Mi*x;
wy=Mi*y;
