%
% Px, Py, Pz - puvodni poloha
% Qx, Qy, Qz - nova poloha
%
function [ wx wy wz ] = TPSSolve3D( Px, Py, Pz, Qx, Qy, Qz )

n=size(Px,1);

norm = (repmat(Px', n, 1) - repmat(Px, 1, n)).^2 + ...
       (repmat(Py', n, 1) - repmat(Py, 1, n)).^2 + ...
       (repmat(Pz', n, 1) - repmat(Pz, 1, n)).^2;
U = RBF(sqrt(norm));
U

M = [ones(n,1) Px Py Pz U;
     zeros(4,4) [ones(1, n); Px'; Py'; Pz']];

M

Mi = inv(M);

x=[Qx; zeros(4,1)];
y=[Qy; zeros(4,1)];
z=[Qz; zeros(4,1)];

wx=Mi*x;
wy=Mi*y;
wz=Mi*z;

