%data
P=[0 0; 0 1; 1 1; 1 0; 0.5 0.5];
Q=[0 0; 0 1; 1 1; 1 0; 0.5 0.75];

Px=P(:,1);Py=P(:,2);
Qx=Q(:,1);Qy=Q(:,2);

n=size(P,1);

%tps
norm = (repmat(Px', n, 1) - repmat(Px, 1, n)).^2 + (repmat(Py', n, 1) - repmat(Py, 1, n)).^2;
U = RBF(sqrt(norm));

M = [ones(n,1) Px Py U;
     zeros(3,3) [ones(1, n); Px'; Py']];

Mi=inv(M);

wx=Mi*[Qx; 0; 0; 0];
wy=Mi*[Qy; 0; 0; 0];

%bending energy matrix
E=Mi(4:n+3,1:n);

%principal warps
[V,D] = eig(E);

%componenty -> koeficienty TPS
v1=V(:,2)'
v2=V(:,3)'

%kombinace warpu
M=[v1(1)  v2(1);
v1(2)  v2(2)];
Mi=inv(M);

%reseni pro x a y
ky=Mi*[wy(4) wy(5)]';
kx=Mi*[wx(4) wx(5)]';

%nakresli principal warpy
TPSPlot([0, 1, 0, 1], [wx(1:3)' v1]', [wy(1:3)' v1]', P, 0.1, 'r' );
TPSPlot([0, 1, 0, 1], [wx(1:3)' v2]', [wy(1:3)' v2]', P, 0.1, 'b' );

%nakresli kombinaci warpu
TPSPlot([0, 1, 0, 1], [wx(1:3)' kx(1)*v1+kx(2)*v2]', [wy(1:3)' ky(1)*v1+ky(2)*v2]', P, 0.1, 'g' );

%nakresli TPS
TPSPlot([0, 1, 0, 1], wx, wy, P, 0.1, 'm' );
plot(P(:,1), P(:,2), 'bo');
plot(Q(:,1), Q(:,2), 'ro');

%vypis koeficienty (partial warps score)
kx
ky

%prokrustovska vzdalenost
pd=sum([kx; ky].^2)
