function [ k ] = partialWarpsScores( P, Q )

Px = P(:,1);Py = P(:,2);
Qx = Q(:,1);Qy = Q(:,2);

n=size(P,1);

%TPS 
norm = (repmat(Px', n, 1) - repmat(Px, 1, n)).^2 + (repmat(Py', n, 1) - repmat(Py, 1, n)).^2;
U = RBF(sqrt(norm));

M = [ones(n,1) Px Py U;
     zeros(3,3) [ones(1, n); Px'; Py']];

Mi=inv(M);

%TPS koeficienty
wx=Mi*[Qx; 0; 0; 0];
wy=Mi*[Qy; 0; 0; 0];

%bending energy matrix
E=Mi(4:n+3,1:n);

%principal warps
[V,D] = eig(E);

%partial warps score
w=abs(diag(D))>0.00001;
PW=V(:,w);
PWi=inv(PW(1:n-3,:));

%reseni pro x a y
wxx=wx(3:end);
wyy=wy(3:end);
ky=PWi*[wyy(w)];
kx=PWi*[wxx(w)];

k=[kx ky];

